﻿using GrapeCity.Documents.Excel;
using System;
using System.Drawing;

namespace FindandReplace
{
    class Program
    {
static void Main(string[] args)
{
    Workbook workbook = new Workbook();
    workbook.Open("supermarket_sales.xlsx");
            
    IRange searchRange = null;
    int countofSheet = workbook.Worksheets.Count;

    #region Highlight Cash Payment

    //Find and highlight the payments made using Cash

    IRange cellWithCashText = null;  //cell to begin search with

    for (int i = 0; i < countofSheet; i++)
    {
        searchRange = workbook.Worksheets[i].GetUsedRange(UsedRangeType.Data);
        cellWithCashText = searchRange.Find("Cash", cellWithCashText, null);
        do
        {
            cellWithCashText.Interior.Color = Color.Gold;            
            cellWithCashText = searchRange.Find("Cash", cellWithCashText, null); //change search cell position to next one
        }
        while (cellWithCashText != null); //iterate until cell with search text is not found
            }
    #endregion


    #region Branch Name Update

    //Exchange the coded Branch with actual Branch names

    IRange cellWithBranch = null;
    FindOptions fo = new FindOptions();
    string[] branches = { "A", "B", "G" };

    for (int i = 0; i < countofSheet; i++)
    {
        searchRange = workbook.Worksheets[i].GetUsedRange(UsedRangeType.Data);
        fo.LookAt = LookAt.Whole;
        foreach (var branch in branches)
        {
            cellWithBranch = searchRange.Find(branch, cellWithBranch, fo);
            do
            {
                switch (cellWithBranch.Value)
                {
                    case "A":
                        cellWithBranch.Value = "Alpha";
                        break;
                    case "B":
                        cellWithBranch.Value = "Beta";
                        break;
                    case "G":
                        cellWithBranch.Value = "Gamma";
                        break;
                    default:
                        break;
                }
                cellWithBranch = searchRange.Find(branch, cellWithBranch, null);
            }
            while (cellWithBranch != null);
        }
    }
    #endregion


    #region Spelling Correction

    //Correct the misspelled part “accesories” in the product line with the correct text. 

    ReplaceOptions ro = new ReplaceOptions();

    for (int i = 0; i < countofSheet; i++)
    {
        searchRange = workbook.Worksheets[i].GetUsedRange(UsedRangeType.Data);
        ro.LookAt = LookAt.Part;                
        searchRange.Replace("accesories", "accessories", ro);                
    }
    #endregion

    workbook.Save("supermarket_sales_updated.xlsx");

}
    }
}
